{
    "$graph": [
        {
            "class": "Workflow",
            "label": "Subworkflow that runs cnvkit in single sample mode and returns a vcf file",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "default": "cnvkit.vcf",
                    "id": "#cnvkit_single_sample.cwl/cnvkit_vcf_name"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "hybrid",
                    "id": "#cnvkit_single_sample.cwl/method"
                },
                {
                    "type": "File",
                    "id": "#cnvkit_single_sample.cwl/reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#cnvkit_single_sample.cwl/scatter_plot"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#cnvkit_single_sample.cwl/segment_filter/ampdel",
                                "#cnvkit_single_sample.cwl/segment_filter/ci",
                                "#cnvkit_single_sample.cwl/segment_filter/cn",
                                "#cnvkit_single_sample.cwl/segment_filter/sem"
                            ]
                        }
                    ],
                    "id": "#cnvkit_single_sample.cwl/segment_filter"
                },
                {
                    "type": "File",
                    "id": "#cnvkit_single_sample.cwl/tumor_bam"
                }
            ],
            "steps": [
                {
                    "run": "#cnvkit_vcf_export.cwl",
                    "in": [
                        {
                            "source": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bin_level_ratios",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/cnr_file"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_segmented_ratios",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/cns_file"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/male_reference",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/male_reference"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/cnvkit_vcf_name",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/output_name"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/segment_filter",
                            "id": "#cnvkit_single_sample.cwl/cns_to_vcf/segment_filter"
                        }
                    ],
                    "out": [
                        "#cnvkit_single_sample.cwl/cns_to_vcf/cnvkit_vcf"
                    ],
                    "id": "#cnvkit_single_sample.cwl/cns_to_vcf"
                },
                {
                    "run": "#cnvkit_batch.cwl",
                    "in": [
                        {
                            "source": "#cnvkit_single_sample.cwl/diagram",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/diagram"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/drop_low_coverage",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/drop_low_coverage"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/male_reference",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/male_reference"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/method",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/method"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/reference_cnn",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/reference_cnn"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/scatter_plot",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/scatter_plot"
                        },
                        {
                            "source": "#cnvkit_single_sample.cwl/tumor_bam",
                            "id": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bam"
                        }
                    ],
                    "out": [
                        "#cnvkit_single_sample.cwl/cnvkit_main/cn_diagram",
                        "#cnvkit_single_sample.cwl/cnvkit_main/cn_scatter_plot",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_antitarget_coverage",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_target_coverage",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bin_level_ratios",
                        "#cnvkit_single_sample.cwl/cnvkit_main/tumor_segmented_ratios"
                    ],
                    "id": "#cnvkit_single_sample.cwl/cnvkit_main"
                }
            ],
            "id": "#cnvkit_single_sample.cwl",
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/cn_diagram",
                    "id": "#cnvkit_single_sample.cwl/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/cn_scatter_plot",
                    "id": "#cnvkit_single_sample.cwl/cn_scatter_plot"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cns_to_vcf/cnvkit_vcf",
                    "id": "#cnvkit_single_sample.cwl/cnvkit_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_antitarget_coverage",
                    "id": "#cnvkit_single_sample.cwl/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_bin_level_ratios",
                    "id": "#cnvkit_single_sample.cwl/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_segmented_ratios",
                    "id": "#cnvkit_single_sample.cwl/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#cnvkit_single_sample.cwl/cnvkit_main/tumor_target_coverage",
                    "id": "#cnvkit_single_sample.cwl/tumor_target_coverage"
                }
            ]
        },
        {
            "class": "Workflow",
            "label": "Merge, annotate, and generate a TSV for SVs",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#merge_svs.cwl/cohort_name"
                },
                {
                    "type": "boolean",
                    "id": "#merge_svs.cwl/estimate_sv_distance"
                },
                {
                    "type": "string",
                    "id": "#merge_svs.cwl/genome_build"
                },
                {
                    "type": "int",
                    "id": "#merge_svs.cwl/max_distance_to_merge"
                },
                {
                    "type": "int",
                    "id": "#merge_svs.cwl/minimum_sv_calls"
                },
                {
                    "type": "int",
                    "id": "#merge_svs.cwl/minimum_sv_size"
                },
                {
                    "type": "boolean",
                    "id": "#merge_svs.cwl/same_strand"
                },
                {
                    "type": "boolean",
                    "id": "#merge_svs.cwl/same_type"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#merge_svs.cwl/snps_vcf"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#merge_svs.cwl/sv_vcfs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/bcftools_annotate_variants/sv_variants_tsv",
                    "id": "#merge_svs.cwl/bcftools_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/bcftools_annotsv_filter/filtered_tsv",
                    "id": "#merge_svs.cwl/bcftools_merged_filtered_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf/bgzipped_file",
                    "id": "#merge_svs.cwl/bcftools_merged_sv_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/survivor_annotate_variants/sv_variants_tsv",
                    "id": "#merge_svs.cwl/survivor_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf/bgzipped_file",
                    "id": "#merge_svs.cwl/survivor_merged_sv_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#annotsv.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/genome_build",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/genome_build"
                        },
                        {
                            "source": "#merge_svs.cwl/bcftools_merge_sv_vcfs/merged_sv_vcf",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/input_vcf"
                        },
                        {
                            "default": "bcftools-merged-AnnotSV.tsv",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/output_tsv_name"
                        },
                        {
                            "source": [
                                "#merge_svs.cwl/snps_vcf"
                            ],
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#merge_svs.cwl/bcftools_annotate_variants/snps_vcf"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_annotate_variants/sv_variants_tsv"
                    ],
                    "id": "#merge_svs.cwl/bcftools_annotate_variants"
                },
                {
                    "run": "#annotsv_filter.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/bcftools_annotate_variants/sv_variants_tsv",
                            "id": "#merge_svs.cwl/bcftools_annotsv_filter/annotsv_tsv"
                        },
                        {
                            "default": "0.05",
                            "id": "#merge_svs.cwl/bcftools_annotsv_filter/filtering_frequency"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_annotsv_filter/filtered_tsv"
                    ],
                    "id": "#merge_svs.cwl/bcftools_annotsv_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/bcftools_merge_sv_vcfs/merged_sv_vcf",
                            "id": "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf/file"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf/bgzipped_file"
                    ],
                    "id": "#merge_svs.cwl/bcftools_bgzip_merged_sv_vcf"
                },
                {
                    "run": "#bcftools_merge.cwl",
                    "in": [
                        {
                            "default": "none",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/merge_method"
                        },
                        {
                            "default": "v",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/output_type"
                        },
                        {
                            "default": "bcftools-sv-merged.vcf",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/output_vcf_name"
                        },
                        {
                            "source": "#merge_svs.cwl/sv_vcfs",
                            "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs/vcfs"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/bcftools_merge_sv_vcfs/merged_sv_vcf"
                    ],
                    "id": "#merge_svs.cwl/bcftools_merge_sv_vcfs"
                },
                {
                    "run": "#annotsv.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/genome_build",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/genome_build"
                        },
                        {
                            "source": "#merge_svs.cwl/survivor_merge_sv_vcfs/merged_vcf",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/input_vcf"
                        },
                        {
                            "default": "SURVIVOR-merged-AnnotSV.tsv",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/output_tsv_name"
                        },
                        {
                            "source": [
                                "#merge_svs.cwl/snps_vcf"
                            ],
                            "valueFrom": "${ return [ self ]; }",
                            "id": "#merge_svs.cwl/survivor_annotate_variants/snps_vcf"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/survivor_annotate_variants/sv_variants_tsv"
                    ],
                    "id": "#merge_svs.cwl/survivor_annotate_variants"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#merge_svs.cwl/survivor_merge_sv_vcfs/merged_vcf",
                            "id": "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf/file"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf/bgzipped_file"
                    ],
                    "id": "#merge_svs.cwl/survivor_bgzip_merged_sv_vcf"
                },
                {
                    "run": "#survivor.cwl",
                    "in": [
                        {
                            "default": "SURVIVOR-sv-merged.vcf",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/cohort_name"
                        },
                        {
                            "source": "#merge_svs.cwl/estimate_sv_distance",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/estimate_sv_distance"
                        },
                        {
                            "source": "#merge_svs.cwl/max_distance_to_merge",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/max_distance_to_merge"
                        },
                        {
                            "source": "#merge_svs.cwl/minimum_sv_calls",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/minimum_sv_calls"
                        },
                        {
                            "source": "#merge_svs.cwl/minimum_sv_size",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/minimum_sv_size"
                        },
                        {
                            "source": "#merge_svs.cwl/same_strand",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/same_strand"
                        },
                        {
                            "source": "#merge_svs.cwl/same_type",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/same_type"
                        },
                        {
                            "source": "#merge_svs.cwl/sv_vcfs",
                            "id": "#merge_svs.cwl/survivor_merge_sv_vcfs/vcfs"
                        }
                    ],
                    "out": [
                        "#merge_svs.cwl/survivor_merge_sv_vcfs/merged_vcf"
                    ],
                    "id": "#merge_svs.cwl/survivor_merge_sv_vcfs"
                }
            ],
            "id": "#merge_svs.cwl"
        },
        {
            "class": "Workflow",
            "label": "Subworkflow to allow calling different SV callers which require bam files as inputs",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".bai",
                        "^.bai"
                    ],
                    "id": "#main/bam"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#main/cnv_deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#main/cnv_duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/cnv_filter_min_size"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/cnvkit_method"
                },
                {
                    "type": "File",
                    "id": "#main/cnvkit_reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/cnvkit_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/cnvkit_vcf_name"
                },
                {
                    "type": "string",
                    "id": "#main/genome_build"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#main/manta_call_regions"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/manta_non_wgs"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "id": "#main/manta_output_contigs"
                },
                {
                    "type": "boolean",
                    "id": "#main/merge_estimate_sv_distance"
                },
                {
                    "type": "int",
                    "id": "#main/merge_max_distance"
                },
                {
                    "type": "int",
                    "id": "#main/merge_min_sv_size"
                },
                {
                    "type": "int",
                    "id": "#main/merge_min_svs"
                },
                {
                    "type": "boolean",
                    "id": "#main/merge_same_strand"
                },
                {
                    "type": "boolean",
                    "id": "#main/merge_same_type"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "id": "#main/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/smoove_exclude_regions"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#main/snps_vcf"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#main/sv_alt_abundance_percentage"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/sv_paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#main/sv_split_count"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/run_merge/bcftools_merged_annotated_tsv",
                    "id": "#main/bcftools_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_merge/bcftools_merged_filtered_annotated_tsv",
                    "id": "#main/bcftools_merged_filtered_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_merge/bcftools_merged_sv_vcf",
                    "id": "#main/bcftools_merged_vcf"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/cn_diagram",
                    "id": "#main/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_cnvkit/cn_scatter_plot",
                    "id": "#main/cn_scatter_plot"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit_filter/filtered_vcf",
                    "id": "#main/cnvkit_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit_raw_index/indexed_vcf",
                    "id": "#main/cnvkit_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvnator/cn_file",
                    "id": "#main/cnvnator_cn_file"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvnator_filter/filtered_vcf",
                    "id": "#main/cnvnator_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvnator/root_file",
                    "id": "#main/cnvnator_root"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvnator_raw_index/indexed_vcf",
                    "id": "#main/cnvnator_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_manta/all_candidates",
                    "id": "#main/manta_all_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_manta/diploid_variants",
                    "id": "#main/manta_diploid_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_manta_filter/filtered_vcf",
                    "id": "#main/manta_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_manta/small_candidates",
                    "id": "#main/manta_small_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_manta/somatic_variants",
                    "id": "#main/manta_somatic_variants"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputSource": "#main/run_manta/tumor_only_variants",
                    "id": "#main/manta_tumor_only_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_smoove_filter/filtered_vcf",
                    "id": "#main/smoove_filtered_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_smoove/output_vcf",
                    "id": "#main/smoove_output_variants"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_merge/survivor_merged_annotated_tsv",
                    "id": "#main/survivor_merged_annotated_tsv"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_merge/survivor_merged_sv_vcf",
                    "id": "#main/survivor_merged_vcf"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_antitarget_coverage",
                    "id": "#main/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_bin_level_ratios",
                    "id": "#main/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_segmented_ratios",
                    "id": "#main/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputSource": "#main/run_cnvkit/tumor_target_coverage",
                    "id": "#main/tumor_target_coverage"
                }
            ],
            "steps": [
                {
                    "run": "#cnvkit_single_sample.cwl",
                    "in": [
                        {
                            "source": "#main/cnvkit_vcf_name",
                            "id": "#main/run_cnvkit/cnvkit_vcf_name"
                        },
                        {
                            "source": "#main/cnvkit_diagram",
                            "id": "#main/run_cnvkit/diagram"
                        },
                        {
                            "source": "#main/cnvkit_drop_low_coverage",
                            "id": "#main/run_cnvkit/drop_low_coverage"
                        },
                        {
                            "source": "#main/cnvkit_male_reference",
                            "id": "#main/run_cnvkit/male_reference"
                        },
                        {
                            "source": "#main/cnvkit_method",
                            "id": "#main/run_cnvkit/method"
                        },
                        {
                            "source": "#main/cnvkit_reference_cnn",
                            "id": "#main/run_cnvkit/reference_cnn"
                        },
                        {
                            "source": "#main/cnvkit_scatter_plot",
                            "id": "#main/run_cnvkit/scatter_plot"
                        },
                        {
                            "default": "cn",
                            "id": "#main/run_cnvkit/segment_filter"
                        },
                        {
                            "source": "#main/bam",
                            "id": "#main/run_cnvkit/tumor_bam"
                        }
                    ],
                    "out": [
                        "#main/run_cnvkit/cn_diagram",
                        "#main/run_cnvkit/cn_scatter_plot",
                        "#main/run_cnvkit/tumor_antitarget_coverage",
                        "#main/run_cnvkit/tumor_target_coverage",
                        "#main/run_cnvkit/tumor_bin_level_ratios",
                        "#main/run_cnvkit/tumor_segmented_ratios",
                        "#main/run_cnvkit/cnvkit_vcf"
                    ],
                    "id": "#main/run_cnvkit"
                },
                {
                    "run": "#sv_depth_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#main/cnv_deletion_depth",
                            "id": "#main/run_cnvkit_filter/deletion_depth"
                        },
                        {
                            "source": "#main/cnv_duplication_depth",
                            "id": "#main/run_cnvkit_filter/duplication_depth"
                        },
                        {
                            "source": "#main/cnv_filter_min_size",
                            "id": "#main/run_cnvkit_filter/min_sv_size"
                        },
                        {
                            "default": "filtered_cnvkit.vcf",
                            "id": "#main/run_cnvkit_filter/output_vcf_name"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_cnvkit_filter/reference"
                        },
                        {
                            "source": "#main/run_cnvkit/cnvkit_vcf",
                            "id": "#main/run_cnvkit_filter/sv_vcf"
                        },
                        {
                            "default": "cnvkit",
                            "id": "#main/run_cnvkit_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#main/run_cnvkit_filter/filtered_vcf"
                    ],
                    "id": "#main/run_cnvkit_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#main/run_cnvkit/cnvkit_vcf",
                            "id": "#main/run_cnvkit_raw_bgzip/file"
                        }
                    ],
                    "out": [
                        "#main/run_cnvkit_raw_bgzip/bgzipped_file"
                    ],
                    "id": "#main/run_cnvkit_raw_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#main/run_cnvkit_raw_bgzip/bgzipped_file",
                            "id": "#main/run_cnvkit_raw_index/vcf"
                        }
                    ],
                    "out": [
                        "#main/run_cnvkit_raw_index/indexed_vcf"
                    ],
                    "id": "#main/run_cnvkit_raw_index"
                },
                {
                    "run": "#cnvnator.cwl",
                    "in": [
                        {
                            "source": "#main/bam",
                            "id": "#main/run_cnvnator/bam"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_cnvnator/reference"
                        },
                        {
                            "default": "cnvnator",
                            "id": "#main/run_cnvnator/sample_name"
                        }
                    ],
                    "out": [
                        "#main/run_cnvnator/vcf",
                        "#main/run_cnvnator/root_file",
                        "#main/run_cnvnator/cn_file"
                    ],
                    "id": "#main/run_cnvnator"
                },
                {
                    "run": "#sv_depth_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#main/cnv_deletion_depth",
                            "id": "#main/run_cnvnator_filter/deletion_depth"
                        },
                        {
                            "source": "#main/cnv_duplication_depth",
                            "id": "#main/run_cnvnator_filter/duplication_depth"
                        },
                        {
                            "source": "#main/cnv_filter_min_size",
                            "id": "#main/run_cnvnator_filter/min_sv_size"
                        },
                        {
                            "default": "filtered_cnvnator.vcf",
                            "id": "#main/run_cnvnator_filter/output_vcf_name"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_cnvnator_filter/reference"
                        },
                        {
                            "source": "#main/run_cnvnator/vcf",
                            "id": "#main/run_cnvnator_filter/sv_vcf"
                        },
                        {
                            "default": "cnvnator",
                            "id": "#main/run_cnvnator_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#main/run_cnvnator_filter/filtered_vcf"
                    ],
                    "id": "#main/run_cnvnator_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#main/run_cnvnator/vcf",
                            "id": "#main/run_cnvnator_raw_bgzip/file"
                        }
                    ],
                    "out": [
                        "#main/run_cnvnator_raw_bgzip/bgzipped_file"
                    ],
                    "id": "#main/run_cnvnator_raw_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#main/run_cnvnator_raw_bgzip/bgzipped_file",
                            "id": "#main/run_cnvnator_raw_index/vcf"
                        }
                    ],
                    "out": [
                        "#main/run_cnvnator_raw_index/indexed_vcf"
                    ],
                    "id": "#main/run_cnvnator_raw_index"
                },
                {
                    "run": "#manta_somatic.cwl",
                    "in": [
                        {
                            "source": "#main/manta_call_regions",
                            "id": "#main/run_manta/call_regions"
                        },
                        {
                            "source": "#main/manta_non_wgs",
                            "id": "#main/run_manta/non_wgs"
                        },
                        {
                            "source": "#main/manta_output_contigs",
                            "id": "#main/run_manta/output_contigs"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_manta/reference"
                        },
                        {
                            "source": "#main/bam",
                            "id": "#main/run_manta/tumor_bam"
                        }
                    ],
                    "out": [
                        "#main/run_manta/diploid_variants",
                        "#main/run_manta/somatic_variants",
                        "#main/run_manta/all_candidates",
                        "#main/run_manta/small_candidates",
                        "#main/run_manta/tumor_only_variants"
                    ],
                    "id": "#main/run_manta"
                },
                {
                    "run": "#sv_paired_read_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#main/sv_alt_abundance_percentage",
                            "id": "#main/run_manta_filter/abundance_percentage"
                        },
                        {
                            "source": "#main/bam",
                            "id": "#main/run_manta_filter/bam"
                        },
                        {
                            "source": "#main/cnv_deletion_depth",
                            "id": "#main/run_manta_filter/deletion_depth"
                        },
                        {
                            "source": "#main/cnv_duplication_depth",
                            "id": "#main/run_manta_filter/duplication_depth"
                        },
                        {
                            "default": "filtered_manta.vcf",
                            "id": "#main/run_manta_filter/output_vcf_name"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_manta_filter/reference"
                        },
                        {
                            "source": "#main/snps_vcf",
                            "id": "#main/run_manta_filter/snps_vcf"
                        },
                        {
                            "source": "#main/sv_paired_count",
                            "id": "#main/run_manta_filter/sv_paired_count"
                        },
                        {
                            "source": "#main/sv_split_count",
                            "id": "#main/run_manta_filter/sv_split_count"
                        },
                        {
                            "source": "#main/run_manta/tumor_only_variants",
                            "id": "#main/run_manta_filter/sv_vcf"
                        },
                        {
                            "default": "manta",
                            "id": "#main/run_manta_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#main/run_manta_filter/filtered_vcf"
                    ],
                    "id": "#main/run_manta_filter"
                },
                {
                    "run": "#merge_svs.cwl",
                    "in": [
                        {
                            "source": "#main/merge_estimate_sv_distance",
                            "id": "#main/run_merge/estimate_sv_distance"
                        },
                        {
                            "source": "#main/genome_build",
                            "id": "#main/run_merge/genome_build"
                        },
                        {
                            "source": "#main/merge_max_distance",
                            "id": "#main/run_merge/max_distance_to_merge"
                        },
                        {
                            "source": "#main/merge_min_svs",
                            "id": "#main/run_merge/minimum_sv_calls"
                        },
                        {
                            "source": "#main/merge_min_sv_size",
                            "id": "#main/run_merge/minimum_sv_size"
                        },
                        {
                            "source": "#main/merge_same_strand",
                            "id": "#main/run_merge/same_strand"
                        },
                        {
                            "source": "#main/merge_same_type",
                            "id": "#main/run_merge/same_type"
                        },
                        {
                            "source": "#main/snps_vcf",
                            "id": "#main/run_merge/snps_vcf"
                        },
                        {
                            "source": [
                                "#main/run_cnvkit_filter/filtered_vcf",
                                "#main/run_cnvnator_filter/filtered_vcf",
                                "#main/run_manta_filter/filtered_vcf",
                                "#main/run_smoove_filter/filtered_vcf"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/run_merge/sv_vcfs"
                        }
                    ],
                    "out": [
                        "#main/run_merge/bcftools_merged_sv_vcf",
                        "#main/run_merge/bcftools_merged_annotated_tsv",
                        "#main/run_merge/bcftools_merged_filtered_annotated_tsv",
                        "#main/run_merge/survivor_merged_sv_vcf",
                        "#main/run_merge/survivor_merged_annotated_tsv"
                    ],
                    "id": "#main/run_merge"
                },
                {
                    "run": "#smoove.cwl",
                    "in": [
                        {
                            "source": [
                                "#main/bam"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/run_smoove/bams"
                        },
                        {
                            "source": "#main/smoove_exclude_regions",
                            "id": "#main/run_smoove/exclude_regions"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_smoove/reference"
                        }
                    ],
                    "out": [
                        "#main/run_smoove/output_vcf"
                    ],
                    "id": "#main/run_smoove"
                },
                {
                    "run": "#sv_paired_read_caller_filter.cwl",
                    "in": [
                        {
                            "source": "#main/sv_alt_abundance_percentage",
                            "id": "#main/run_smoove_filter/abundance_percentage"
                        },
                        {
                            "source": "#main/bam",
                            "id": "#main/run_smoove_filter/bam"
                        },
                        {
                            "source": "#main/cnv_deletion_depth",
                            "id": "#main/run_smoove_filter/deletion_depth"
                        },
                        {
                            "source": "#main/cnv_duplication_depth",
                            "id": "#main/run_smoove_filter/duplication_depth"
                        },
                        {
                            "default": "filtered_smoove.vcf",
                            "id": "#main/run_smoove_filter/output_vcf_name"
                        },
                        {
                            "source": "#main/reference",
                            "id": "#main/run_smoove_filter/reference"
                        },
                        {
                            "source": "#main/snps_vcf",
                            "id": "#main/run_smoove_filter/snps_vcf"
                        },
                        {
                            "source": "#main/sv_paired_count",
                            "id": "#main/run_smoove_filter/sv_paired_count"
                        },
                        {
                            "source": "#main/sv_split_count",
                            "id": "#main/run_smoove_filter/sv_split_count"
                        },
                        {
                            "source": "#main/run_smoove/output_vcf",
                            "id": "#main/run_smoove_filter/sv_vcf"
                        },
                        {
                            "default": "smoove",
                            "id": "#main/run_smoove_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#main/run_smoove_filter/filtered_vcf"
                    ],
                    "id": "#main/run_smoove_filter"
                }
            ],
            "id": "#main"
        },
        {
            "class": "Workflow",
            "label": "Filter single sample sv vcf from depth callers(cnvkit/cnvnator)",
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/min_sv_size"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/output_vcf_name"
                },
                {
                    "type": "string",
                    "id": "#sv_depth_caller_filter.cwl/reference"
                },
                {
                    "type": "File",
                    "id": "#sv_depth_caller_filter.cwl/sv_vcf"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#sv_depth_caller_filter.cwl/vcf_source/cnvkit",
                                "#sv_depth_caller_filter.cwl/vcf_source/cnvnator"
                            ]
                        }
                    ],
                    "id": "#sv_depth_caller_filter.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#sv_depth_caller_filter.cwl/filtered_vcf_index/indexed_vcf",
                    "id": "#sv_depth_caller_filter.cwl/filtered_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#filter_sv_vcf_depth.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/deletion_depth",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/deletion_depth"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/duplication_depth",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/duplication_depth"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/size_filter/filtered_sv_vcf",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/input_vcf"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/output_vcf_name",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/output_vcf_name"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/vcf_source",
                            "id": "#sv_depth_caller_filter.cwl/depth_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/depth_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/depth_filter"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/depth_filter/filtered_sv_vcf",
                            "id": "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip/file"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file",
                            "id": "#sv_depth_caller_filter.cwl/filtered_vcf_index/vcf"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/filtered_vcf_index/indexed_vcf"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/filtered_vcf_index"
                },
                {
                    "run": "#filter_sv_vcf_size.cwl",
                    "in": [
                        {
                            "source": "#sv_depth_caller_filter.cwl/sv_vcf",
                            "id": "#sv_depth_caller_filter.cwl/size_filter/input_vcf"
                        },
                        {
                            "default": "min_len",
                            "id": "#sv_depth_caller_filter.cwl/size_filter/size_method"
                        },
                        {
                            "source": "#sv_depth_caller_filter.cwl/min_sv_size",
                            "id": "#sv_depth_caller_filter.cwl/size_filter/sv_size"
                        }
                    ],
                    "out": [
                        "#sv_depth_caller_filter.cwl/size_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_depth_caller_filter.cwl/size_filter"
                }
            ],
            "id": "#sv_depth_caller_filter.cwl"
        },
        {
            "class": "Workflow",
            "label": "Filter single sample sv vcf from paired read callers(Manta/Smoove)",
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/abundance_percentage"
                },
                {
                    "type": "File",
                    "id": "#sv_paired_read_caller_filter.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/duplication_depth"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/output_vcf_name"
                },
                {
                    "type": "string",
                    "id": "#sv_paired_read_caller_filter.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/snps_vcf"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/sv_paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/sv_split_count"
                },
                {
                    "type": "File",
                    "id": "#sv_paired_read_caller_filter.cwl/sv_vcf"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#sv_paired_read_caller_filter.cwl/vcf_source/manta",
                                "#sv_paired_read_caller_filter.cwl/vcf_source/smoove"
                            ]
                        }
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#sv_paired_read_caller_filter.cwl/filtered_vcf_index/indexed_vcf",
                    "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf"
                }
            ],
            "steps": [
                {
                    "run": "#filter_sv_vcf_depth.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/deletion_depth",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/deletion_depth"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/duplication_depth",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/duplication_depth"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/duphold_annotate/annotated_sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/input_vcf"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/output_vcf_name",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/output_vcf_name"
                        },
                        {
                            "default": "duphold",
                            "id": "#sv_paired_read_caller_filter.cwl/depth_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/depth_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/depth_filter"
                },
                {
                    "run": "#duphold.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/bam",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/bam"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/reference",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/reference"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/snps_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/snps_vcf"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/read_support_filter/filtered_sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate/sv_vcf"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/duphold_annotate/annotated_sv_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/duphold_annotate"
                },
                {
                    "run": "#bgzip.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/depth_filter/filtered_sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip/file"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip"
                },
                {
                    "run": "#index_vcf.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/filtered_vcf_bgzip/bgzipped_file",
                            "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_index/vcf"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/filtered_vcf_index/indexed_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/filtered_vcf_index"
                },
                {
                    "run": "#filter_sv_vcf_read_support.cwl",
                    "in": [
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/abundance_percentage",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/abundance_percentage"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/sv_vcf",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/input_vcf"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/sv_paired_count",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/paired_count"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/sv_split_count",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/split_count"
                        },
                        {
                            "source": "#sv_paired_read_caller_filter.cwl/vcf_source",
                            "id": "#sv_paired_read_caller_filter.cwl/read_support_filter/vcf_source"
                        }
                    ],
                    "out": [
                        "#sv_paired_read_caller_filter.cwl/read_support_filter/filtered_sv_vcf"
                    ],
                    "id": "#sv_paired_read_caller_filter.cwl/read_support_filter"
                }
            ],
            "id": "#sv_paired_read_caller_filter.cwl"
        },
        {
            "class": "CommandLineTool",
            "arguments": [
                "AnnotSV",
                "-bedtools",
                "/usr/bin/bedtools",
                "-outputDir",
                "$(runtime.outdir)"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/annotsv-cwl:2.1"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-genomeBuild"
                    },
                    "id": "#annotsv.cwl/genome_build"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-SVinputFile"
                    },
                    "doc": "vcf file to filter",
                    "id": "#annotsv.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "AnnotSV.tsv",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "-outputFile"
                    },
                    "doc": "output file name",
                    "id": "#annotsv.cwl/output_tsv_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-vcfFiles",
                        "itemSeparator": ","
                    },
                    "doc": "snps vcf(s) for adding hom/het snp counts found within svs",
                    "id": "#annotsv.cwl/snps_vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_tsv_name)"
                    },
                    "id": "#annotsv.cwl/sv_variants_tsv"
                }
            ],
            "id": "#annotsv.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "filter AnnotSV tsv output generated from a bcftools merged vcf",
            "baseCommand": [
                "python3",
                "AnnotSV_filter.py"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "python:3"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "AnnotSV_filter.py",
                            "entry": "import argparse\nimport csv\nimport sys\n\nparser = argparse.ArgumentParser()\nparser.add_argument('--input', '-i', dest=\"input\", help='input AnnotSV tsv file', required=True, action=\"store\")\nparser.add_argument('--output', '-o', dest=\"output\", help='output tsv file name', required=True, action=\"store\")\nparser.add_argument('--filtering_frequency', dest=\"filtering_frequency\", help=\"frequency to filter with\", action=\"store\", type=float, default=\"0.05\")\nparser.add_argument('--all-CDS', dest=\"CDS\", help=\"Do not require a positive CoDing Sequence overlap\", action=\"store_true\")\nparser.add_argument('--ignore-pass-filter', dest=\"filter\", help=\"Do not require calls to have a PASS filter\", action=\"store_true\")\n\nargs = parser.parse_args()\ninput_file_name  = args.input\noutput_file_name = args.output\nfiltering_frequency = args.filtering_frequency\nall_cds = args.CDS\nignore_pass_filter = args.filter\n\nwith open(input_file_name, 'r') as file_in, open(output_file_name, 'w') as file_out:\n    file_in = csv.DictReader(file_in, delimiter='\\t')\n    file_out = csv.DictWriter(file_out, fieldnames=file_in.fieldnames, delimiter='\\t')\n    file_out.writeheader()\n    total_sv_count = 0\n    pass_sv_count = 0\n    for row in file_in:\n        total_sv_count += 1\n        if(row['AnnotSV type'] == 'split' \\\n            and (row['FILTER'] == 'PASS' or ignore_pass_filter) \\\n            and (int(row['CDS length']) > 0 or all_cds) \\\n            and float(row['IMH_AF']) < filtering_frequency\n            and float(row['1000g_max_AF']) < filtering_frequency\n            and not(float(row['DGV_LOSS_Frequency']) > filtering_frequency and 'DEL' in row['SV type']) \n            and not(float(row['DGV_GAIN_Frequency']) < filtering_frequency and ('DUP' in row['SV type'] or 'INS' in row['SV type']))\n            and not(('Manta' in row['ID'] and 'IMPRECISE' in row['INFO']) or (row['QUAL'] != '.' and 'IMPRECISE' in row['INFO'])) ):\n            file_out.writerow(row)\n            pass_sv_count += 1\n    print(\"total sv count:\",total_sv_count)\n    print(\"total sv passed count:\",pass_sv_count)\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--all-CDS"
                    },
                    "id": "#annotsv_filter.cwl/all_CDS"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--input"
                    },
                    "id": "#annotsv_filter.cwl/annotsv_tsv"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--filtering_frequency"
                    },
                    "id": "#annotsv_filter.cwl/filtering_frequency"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--ignore-pass-filter"
                    },
                    "id": "#annotsv_filter.cwl/ignore_pass_filter"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered-bcftools-merged-AnnotSV.tsv",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--output"
                    },
                    "id": "#annotsv_filter.cwl/output_tsv_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_tsv_name)"
                    },
                    "id": "#annotsv_filter.cwl/filtered_tsv"
                }
            ],
            "id": "#annotsv_filter.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/opt/bcftools/bin/bcftools",
                "merge"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--force-samples"
                    },
                    "doc": "resolve duplicate sample names",
                    "id": "#bcftools_merge.cwl/force_merge"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#bcftools_merge.cwl/merge_method/none",
                            "#bcftools_merge.cwl/merge_method/snps",
                            "#bcftools_merge.cwl/merge_method/indels",
                            "#bcftools_merge.cwl/merge_method/both",
                            "#bcftools_merge.cwl/merge_method/all",
                            "#bcftools_merge.cwl/merge_method/id"
                        ]
                    },
                    "default": "none",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--merge"
                    },
                    "doc": "method used to merge allow multiallelic indels/snps",
                    "id": "#bcftools_merge.cwl/merge_method"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--missing-to-ref"
                    },
                    "doc": "assume genotypes at missing sites are 0/0",
                    "id": "#bcftools_merge.cwl/missing_ref"
                },
                {
                    "type": {
                        "type": "enum",
                        "symbols": [
                            "#bcftools_merge.cwl/output_type/b",
                            "#bcftools_merge.cwl/output_type/u",
                            "#bcftools_merge.cwl/output_type/z",
                            "#bcftools_merge.cwl/output_type/v"
                        ]
                    },
                    "default": "z",
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--output-type"
                    },
                    "doc": "output file format",
                    "id": "#bcftools_merge.cwl/output_type"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "bcftools_merged.vcf.gz",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--output"
                    },
                    "doc": "output vcf file name",
                    "id": "#bcftools_merge.cwl/output_vcf_name"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 6
                    },
                    "doc": "input bgzipped tabix indexed vcfs to merge",
                    "id": "#bcftools_merge.cwl/vcfs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#bcftools_merge.cwl/merged_sv_vcf"
                }
            ],
            "id": "#bcftools_merge.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "bgzip VCF",
            "baseCommand": [
                "/opt/htslib/bin/bgzip"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "stdout": "$(inputs.file.basename).gz",
            "arguments": [
                "-c"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#bgzip.cwl/file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#bgzip.cwl/bgzipped_file",
                    "outputBinding": {
                        "glob": "$(inputs.file.basename).gz"
                    }
                }
            ],
            "id": "#bgzip.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "batch"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "etal/cnvkit:0.9.5"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "ramMin": 4000,
                    "tmpdirMin": 10000
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--access"
                    },
                    "id": "#cnvkit_batch.cwl/access"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--targets"
                    },
                    "id": "#cnvkit_batch.cwl/bait_intervals"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "--diagram"
                    },
                    "id": "#cnvkit_batch.cwl/diagram"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "--drop-low-coverage"
                    },
                    "id": "#cnvkit_batch.cwl/drop_low_coverage"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-y"
                    },
                    "id": "#cnvkit_batch.cwl/male_reference"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "hybrid",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "--method"
                    },
                    "id": "#cnvkit_batch.cwl/method"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--normal"
                    },
                    "id": "#cnvkit_batch.cwl/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--fasta"
                    },
                    "id": "#cnvkit_batch.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "-r"
                    },
                    "id": "#cnvkit_batch.cwl/reference_cnn"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "--scatter"
                    },
                    "id": "#cnvkit_batch.cwl/scatter_plot"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cnvkit_batch.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot)-diagram.pdf"
                    },
                    "id": "#cnvkit_batch.cwl/cn_diagram"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot)-scatter.pdf"
                    },
                    "id": "#cnvkit_batch.cwl/cn_scatter_plot"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${  \n    var glob_base = \".antitarget.bed\";\n    if (inputs.bait_intervals) {\n        glob_base = inputs.bait_intervals.nameroot + glob_base;\n    }   \n    return glob_base;\n}  \n"
                    },
                    "id": "#cnvkit_batch.cwl/intervals_antitarget"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".target.bed\";\n    if (inputs.bait_intervals) {\n        glob_base = inputs.bait_intervals.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/intervals_target"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".antitargetcoverage.cnn\";\n    if (inputs.normal_bam) {\n        glob_base = inputs.normal_bam.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/normal_antitarget_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "${\n    var glob_base = \".targetcoverage.cnn\";\n    if (inputs.normal_bam) {\n        glob_base = inputs.normal_bam.nameroot + glob_base;\n    }\n    return glob_base;\n}\n"
                    },
                    "id": "#cnvkit_batch.cwl/normal_target_coverage"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "reference.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/reference_coverage"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).antitargetcoverage.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_antitarget_coverage"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).cnr"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_bin_level_ratios"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).cns"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_segmented_ratios"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.tumor_bam.nameroot).targetcoverage.cnn"
                    },
                    "id": "#cnvkit_batch.cwl/tumor_target_coverage"
                }
            ],
            "id": "#cnvkit_batch.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Convert default cnvkit .cns output to standard vcf format",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "etal/cnvkit:0.9.5"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 8000
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": [
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "call"
            ],
            "arguments": [
                {
                    "position": -1,
                    "valueFrom": "$(inputs.male_reference)",
                    "prefix": "-y"
                },
                "-o",
                "adjusted.tumor.cns",
                {
                    "shellQuote": false,
                    "valueFrom": "&&"
                },
                "/usr/bin/python",
                "/usr/local/bin/cnvkit.py",
                "export",
                "vcf",
                "adjusted.tumor.cns"
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--cnr"
                    },
                    "id": "#cnvkit_vcf_export.cwl/cnr_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": -2
                    },
                    "id": "#cnvkit_vcf_export.cwl/cns_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-y"
                    },
                    "id": "#cnvkit_vcf_export.cwl/male_reference"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "-o"
                    },
                    "id": "#cnvkit_vcf_export.cwl/output_name"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#cnvkit_vcf_export.cwl/segment_filter/ampdel",
                                "#cnvkit_vcf_export.cwl/segment_filter/ci",
                                "#cnvkit_vcf_export.cwl/segment_filter/cn",
                                "#cnvkit_vcf_export.cwl/segment_filter/sem"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": -3,
                        "prefix": "--filter"
                    },
                    "doc": "method for filtering/merging neighboring copy number segments",
                    "id": "#cnvkit_vcf_export.cwl/segment_filter"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#cnvkit_vcf_export.cwl/cnvkit_vcf"
                }
            ],
            "id": "#cnvkit_vcf_export.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Run CNVnator to calculate copy number variations in WGS samples",
            "baseCommand": [
                "/bin/bash",
                "run_cnvnator.sh"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/cnvnator-cwl:0.4"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 20000,
                    "coresMin": 1,
                    "tmpdirMin": 10000
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "run_cnvnator.sh",
                            "entry": "#!/bin/bash\n\n#set up the environment\nsource /opt/root/bin/thisroot.sh\n\nset -eou pipefail\n\n# set vars\nBAM=\"$1\"\nBIN_SIZE=\"$2\"\nCHROMOSOMES=\"$3\"\nREFERENCE=\"$4\"\nSAMPLE=\"$5\"\n\n# create directory to store fasta files. CNVnator wants chromosomes in individual files\n# while with later versions of CNVnator these steps will accept a fasta.gz file the cnvnator2VCF.pl will not\nmkdir FASTA_CHRS\nawk 'BEGIN { CHROM=\"\" } { if ($1~\"^>\") CHROM=substr($1,2); print $0 > \"FASTA_CHRS/\"CHROM\".fa\" }' \"$REFERENCE\"\n\n# extract read mapping from input bam(single sample)\ncnvnator -root \"$SAMPLE.root\" -tree \"$BAM\" -chrom $CHROMOSOMES\n# generate read depth histogram\ncnvnator -root \"$SAMPLE.root\" -his \"$BIN_SIZE\" -d FASTA_CHRS/ -chrom $CHROMOSOMES\n# calculate statistics\ncnvnator -root \"$SAMPLE.root\" -stat \"$BIN_SIZE\" -chrom $CHROMOSOMES\n# read depth signal partitioning\ncnvnator -root \"$SAMPLE.root\" -partition \"$BIN_SIZE\" -chrom $CHROMOSOMES\n# cnv calling\ncnvnator -root \"$SAMPLE.root\" -call \"$BIN_SIZE\" -chrom $CHROMOSOMES > \"$SAMPLE.CNVnator.cn\"\n\n# convert to vcf\ncnvnator2VCF.pl -reference \"$REFERENCE\" \"$SAMPLE.CNVnator.cn\" FASTA_CHRS/ >  \"$SAMPLE.CNVnator.vcf\"\nexit 0\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "BAM or CRAM input",
                    "id": "#cnvnator.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 100,
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Bin size used to calculate coverage",
                    "id": "#cnvnator.cwl/bin_size"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "default": [
                        "chr1",
                        "chr2",
                        "chr3",
                        "chr4",
                        "chr5",
                        "chr6",
                        "chr7",
                        "chr8",
                        "chr9",
                        "chr10",
                        "chr11",
                        "chr12",
                        "chr13",
                        "chr14",
                        "chr15",
                        "chr16",
                        "chr17",
                        "chr18",
                        "chr19",
                        "chr20",
                        "chr21",
                        "chr22",
                        "chrX",
                        "chrY"
                    ],
                    "inputBinding": {
                        "position": 3,
                        "itemSeparator": " "
                    },
                    "doc": "List of chromosomes to run CNVnator on",
                    "id": "#cnvnator.cwl/chromosomes"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "Reference used to generate the alignments",
                    "id": "#cnvnator.cwl/reference"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "Sample name used for output file naming",
                    "id": "#cnvnator.cwl/sample_name"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).CNVnator.cn"
                    },
                    "id": "#cnvnator.cwl/cn_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).root"
                    },
                    "id": "#cnvnator.cwl/root_file"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.sample_name).CNVnator.vcf"
                    },
                    "id": "#cnvnator.cwl/vcf"
                }
            ],
            "id": "#cnvnator.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "/usr/bin/duphold",
            "arguments": [
                "--threads",
                "$(runtime.cores)"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 10000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/duphold-cwl:0.1.5"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1,
                        "prefix": "--bam"
                    },
                    "doc": "aligned bam/cram file",
                    "id": "#duphold.cwl/bam"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "duphold_annotated.vcf",
                    "inputBinding": {
                        "position": 2,
                        "prefix": "--output"
                    },
                    "doc": "output vcf file name",
                    "id": "#duphold.cwl/output_vcf_name"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 3,
                        "prefix": "--fasta"
                    },
                    "doc": "reference used to align bam",
                    "id": "#duphold.cwl/reference"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 4,
                        "prefix": "--snp"
                    },
                    "doc": "snps vcf file to annotate hom/het variant counts within sv",
                    "id": "#duphold.cwl/snps_vcf"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "--vcf"
                    },
                    "doc": "sv vcf file to annotate",
                    "id": "#duphold.cwl/sv_vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#duphold.cwl/annotated_sv_vcf"
                }
            ],
            "id": "#duphold.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/bin/bash",
                "filter_sv_vcf_depth.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "filter_sv_vcf_depth.sh",
                            "entry": "#!/bin/bash\nset -eou pipefail\n\nINPUT_VCF=\"$1\"\nOUTPUT_VCF=\"$2\"\nDEL_DEPTH=\"$3\"\nDUP_DEPTH=\"$4\"\nVCF_SOURCE=\"$5\"\n\nif [ \"$VCF_SOURCE\" == \"cnvnator\" ]; then\n  echo \"Running filter for cnvnator vcf\"\n  filter_expression=\"(natorRD>$DUP_DEPTH | natorRD<$DEL_DEPTH)\"\nelif [ \"$VCF_SOURCE\" ==  \"cnvkit\" ]; then\n  echo \"Running filter for cnvkit vcf\"\n  filter_expression=\"(FOLD_CHANGE>$DUP_DEPTH | FOLD_CHANGE<$DEL_DEPTH)\"\nelif [ \"$VCF_SOURCE\" ==  \"duphold\" ]; then\n  echo \"Running filter for vcf annotated by duphold\"\n  filter_expression=\"((SVTYPE='DEL' & FMT/DHFFC[0] < $DEL_DEPTH) | (SVTYPE='DUP' & FMT/DHBFC[0] > $DUP_DEPTH) | SVTYPE='BND' | SVTYPE='INS' | SVTYPE='INV')\"\nelse\n  echo \"vcf source: '$VCF_SOURCE' is not supported for SV filtering\"\n  exit 1\nfi\n/opt/bcftools/bin/bcftools filter \"$INPUT_VCF\" -o \"$OUTPUT_VCF\" -i \"$filter_expression\"\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "default": 0.75,
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "Depth for deletions must be less than this cutoff to pass the filter.",
                    "id": "#filter_sv_vcf_depth.cwl/deletion_depth"
                },
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "default": 1.25,
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "Depth for duplications must be greater than this cutoff to pass the filter.",
                    "id": "#filter_sv_vcf_depth.cwl/duplication_depth"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "vcf file to filter",
                    "id": "#filter_sv_vcf_depth.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered_cnv.vcf",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "output vcf file name",
                    "id": "#filter_sv_vcf_depth.cwl/output_vcf_name"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#filter_sv_vcf_depth.cwl/vcf_source/cnvnator",
                                "#filter_sv_vcf_depth.cwl/vcf_source/cnvkit",
                                "#filter_sv_vcf_depth.cwl/vcf_source/duphold"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "source caller of the vcf input file",
                    "id": "#filter_sv_vcf_depth.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#filter_sv_vcf_depth.cwl/filtered_sv_vcf"
                }
            ],
            "id": "#filter_sv_vcf_depth.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/bin/bash",
                "filter_sv_vcf_read_support.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "filter_sv_vcf_read_support.sh",
                            "entry": "#!/bin/bash\nset -eou pipefail\n\nabundance=\"$1\"\ninput_vcf=\"$2\"\noutput_vcf=\"$3\"\npaired_count=\"$4\"\nsplit_count=\"$5\"\nvcf_source=\"$6\"\n\nif [ \"$vcf_source\" == \"smoove\" ]; then\n  echo \"Running filter for smoove vcf\"\n  filter_expression=\"((AS >= $split_count) && (AP >= $paired_count) && ((AP+AS) / (AP+RP+AS+RS) >= $abundance))\"\nelif [ \"$vcf_source\" ==  \"manta\" ]; then\n  echo \"Running filter for manta vcf\"\n  filter_expression=\"((SR[0:*]=\\\".\\\" || (SR[0:1] >= $split_count)) && (PR[0:1] >= $paired_count) && ((SR[0:*]=\\\".\\\" && (PR[0:1] / (PR[0:0]+PR[0:1]) >= $abundance))|| ((SR[0:1]+PR[0:1]) / (SR[0:0]+SR[0:1]+PR[0:1]+PR[0:0]) >= $abundance)))\"\nelse\n  echo \"vcf source: '$vcf_source' is not supported for SV filtering\"\n  exit 1\nfi\n\n/opt/bcftools/bin/bcftools filter \"$input_vcf\" -o \"$output_vcf\" -i \"$filter_expression\"\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "double"
                    ],
                    "default": 0.1,
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "required alternate read abundance percentage to pass",
                    "id": "#filter_sv_vcf_read_support.cwl/abundance_percentage"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "vcf file to filter",
                    "id": "#filter_sv_vcf_read_support.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered_sv.vcf",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "output vcf file name",
                    "id": "#filter_sv_vcf_read_support.cwl/output_vcf_name"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "number of alternate paired reads support needed to pass",
                    "id": "#filter_sv_vcf_read_support.cwl/paired_count"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 2,
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "if present in variant, number of alternate split reads support needed to pass",
                    "id": "#filter_sv_vcf_read_support.cwl/split_count"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#filter_sv_vcf_read_support.cwl/vcf_source/manta",
                                "#filter_sv_vcf_read_support.cwl/vcf_source/smoove"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 6
                    },
                    "doc": "source caller of the vcf input file",
                    "id": "#filter_sv_vcf_read_support.cwl/vcf_source"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#filter_sv_vcf_read_support.cwl/filtered_sv_vcf"
                }
            ],
            "id": "#filter_sv_vcf_read_support.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "/bin/bash",
                "filter_sv_vcf_size.sh"
            ],
            "requirements": [
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/bcftools-cwl:1.9"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "filter_sv_vcf_size.sh",
                            "entry": "#!/bin/bash\nset -eou pipefail\n\nINPUT_VCF=\"$1\"\nOUTPUT_VCF=\"$2\"\nSV_SIZE=\"$3\"\nFILTER_METHOD=\"$4\"\n\nif [ \"$FILTER_METHOD\" == \"max_len\" ]; then\n  echo \"Running filter for max size svs\"\n  filter_expression=\"ABS(SVLEN) <= $SV_SIZE\"\nelif [ \"$FILTER_METHOD\" ==  \"min_len\" ]; then\n  echo \"Running filter for min size svs\"\n  filter_expression=\"ABS(SVLEN) >= $SV_SIZE\"\nelse\n  echo \"Filter method: '$FILTER_METHOD' is not supported for size SV filtering\"\n  exit 1\nfi\n/opt/bcftools/bin/bcftools filter \"$INPUT_VCF\" -o \"$OUTPUT_VCF\" -i \"$filter_expression\"\n"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "vcf file to filter",
                    "id": "#filter_sv_vcf_size.cwl/input_vcf"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "filtered_sv_size.vcf",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "output vcf file name",
                    "id": "#filter_sv_vcf_size.cwl/output_vcf_name"
                },
                {
                    "type": [
                        {
                            "type": "enum",
                            "symbols": [
                                "#filter_sv_vcf_size.cwl/size_method/max_len",
                                "#filter_sv_vcf_size.cwl/size_method/min_len"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "position": 4
                    },
                    "doc": "method for size filtering",
                    "id": "#filter_sv_vcf_size.cwl/size_method"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 50000,
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "size in bp used for filtering",
                    "id": "#filter_sv_vcf_size.cwl/sv_size"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_vcf_name)"
                    },
                    "id": "#filter_sv_vcf_size.cwl/filtered_sv_vcf"
                }
            ],
            "id": "#filter_sv_vcf_size.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "vcf index",
            "arguments": [
                "cp",
                "$(inputs.vcf.path)",
                "$(runtime.outdir)/$(inputs.vcf.basename)",
                {
                    "valueFrom": " && ",
                    "shellQuote": false
                },
                "/usr/bin/tabix",
                "-p",
                "vcf"
            ],
            "requirements": [
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/samtools-cwl:1.0.0"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 4000
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "valueFrom": "$(self.basename)",
                        "position": 1
                    },
                    "id": "#index_vcf.cwl/vcf"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "outputBinding": {
                        "glob": "$(inputs.vcf.basename)"
                    },
                    "id": "#index_vcf.cwl/indexed_vcf"
                }
            ],
            "id": "#index_vcf.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Set up and execute manta",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/manta_somatic-cwl:1.5.0"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ShellCommandRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 12,
                    "ramMin": 24000,
                    "tmpdirMin": 10000
                }
            ],
            "baseCommand": [
                "/usr/bin/python",
                "/usr/bin/manta/bin/configManta.py"
            ],
            "arguments": [
                {
                    "position": -1,
                    "valueFrom": "$(runtime.outdir)",
                    "prefix": "--runDir"
                },
                {
                    "shellQuote": false,
                    "valueFrom": "&&"
                },
                "/usr/bin/python",
                "runWorkflow.py",
                "-m",
                "local",
                {
                    "position": 1,
                    "valueFrom": "$(runtime.cores)",
                    "prefix": "-j"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": -5,
                        "prefix": "--callRegions"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "doc": "bgzip-compressed, tabix-indexed BED file specifiying regions to which variant analysis will be restricted",
                    "id": "#manta_somatic.cwl/call_regions"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": -6,
                        "prefix": "--exome"
                    },
                    "doc": "toggles on settings for WES",
                    "id": "#manta_somatic.cwl/non_wgs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": -2,
                        "prefix": "--normalBam"
                    },
                    "secondaryFiles": "${if (self.nameext === \".bam\") {return self.basename + \".bai\"} else {return self.basename + \".crai\"}}",
                    "id": "#manta_somatic.cwl/normal_bam"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": -7,
                        "prefix": "--outputContig"
                    },
                    "doc": "if true, outputs assembled contig sequences in final VCF files, in the INFO field CONTIG",
                    "id": "#manta_somatic.cwl/output_contigs"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "position": -4,
                        "prefix": "--referenceFasta"
                    },
                    "id": "#manta_somatic.cwl/reference"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": -3,
                        "prefix": "--tumorBam"
                    },
                    "secondaryFiles": "${if (self.nameext === \".bam\") {return self.basename + \".bai\"} else {return self.basename + \".crai\"}}",
                    "id": "#manta_somatic.cwl/tumor_bam"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "results/variants/candidateSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/all_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "results/variants/diploidSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/diploid_variants"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "results/variants/candidateSmallIndels.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/small_candidates"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "results/variants/somaticSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/somatic_variants"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "results/variants/tumorSV.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".tbi"
                    ],
                    "id": "#manta_somatic.cwl/tumor_only_variants"
                }
            ],
            "id": "#manta_somatic.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Run Smoove v0.1.6",
            "baseCommand": "/usr/local/bin/smoove",
            "arguments": [
                "call",
                "--processes",
                "4",
                "-F"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "brentp/smoove@sha256:9d5098d3882df1443aae36922d36b5188af1cb9b8f83dab4a9ed041a6a8019cc"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 20000,
                    "coresMin": 4,
                    "tmpdirMin": 10000
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "prefix": "--genotype",
                        "position": 1
                    },
                    "doc": "Array of bams to run through lumpy, can be single or small cohort",
                    "id": "#smoove.cwl/bams"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--name",
                        "position": 2
                    },
                    "default": "SV",
                    "doc": "Used for naming the output file",
                    "id": "#smoove.cwl/cohort_name"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "prefix": "--exclude",
                        "position": 4
                    },
                    "doc": "Bed file used to exclude regions",
                    "id": "#smoove.cwl/exclude_regions"
                },
                {
                    "type": [
                        "string",
                        "File"
                    ],
                    "secondaryFiles": [
                        ".fai",
                        "^.dict"
                    ],
                    "inputBinding": {
                        "prefix": "--fasta",
                        "position": 3
                    },
                    "doc": "Reference used to generate the bams",
                    "id": "#smoove.cwl/reference"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.cohort_name)-smoove.genotyped.vcf.gz"
                    },
                    "secondaryFiles": [
                        ".csi"
                    ],
                    "id": "#smoove.cwl/output_vcf"
                }
            ],
            "id": "#smoove.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "Run SURVIVOR to merge SV calls",
            "baseCommand": [
                "/bin/bash",
                "/usr/bin/survivor_merge_helper.sh"
            ],
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "DockerRequirement",
                    "dockerPull": "mgibio/survivor-cwl:1.0.6.2"
                },
                {
                    "class": "ResourceRequirement",
                    "ramMin": 2000,
                    "coresMin": 1
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 8
                    },
                    "default": "SURVIVOR-sv-merged.vcf",
                    "doc": "Used to generate the output file name",
                    "id": "#survivor.cwl/cohort_name"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 6,
                        "valueFrom": "${\n  if(inputs.estimate_sv_distance){\n    return \"1\";\n  } else {\n    return \"0\";\n  }\n}\n"
                    },
                    "doc": "Estimate distance based on the size of SV",
                    "id": "#survivor.cwl/estimate_sv_distance"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 2
                    },
                    "doc": "Maximum distance of variants to consider for merging",
                    "id": "#survivor.cwl/max_distance_to_merge"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 3
                    },
                    "doc": "Minimum number of sv calls needed to be merged",
                    "id": "#survivor.cwl/minimum_sv_calls"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "position": 7
                    },
                    "doc": "Minimum size of SVs to merge",
                    "id": "#survivor.cwl/minimum_sv_size"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 5,
                        "valueFrom": "${\n  if(inputs.same_strand){\n    return \"1\";\n  } else {\n    return \"0\";\n  }\n}\n"
                    },
                    "doc": "Require merged SVs to be on the same strand",
                    "id": "#survivor.cwl/same_strand"
                },
                {
                    "type": "boolean",
                    "inputBinding": {
                        "position": 4,
                        "valueFrom": "${\n  if(inputs.same_type){\n    return \"1\";\n  } else {\n    return \"0\";\n  }\n}\n"
                    },
                    "doc": "Require merged SVs to be of the same type",
                    "id": "#survivor.cwl/same_type"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1,
                        "itemSeparator": ","
                    },
                    "doc": "Array of VCFs to merge SV calls of",
                    "id": "#survivor.cwl/vcfs"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.cohort_name)"
                    },
                    "id": "#survivor.cwl/merged_vcf"
                }
            ],
            "id": "#survivor.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
